
module test_top
(
	input         I_clk      , //50Mhz
	input         I_key1     , //SW1 ,low active
    input         I_key2     , //SW2 ,low active
    input         I_key3     , //SW3 ,low active
    input         I_key4     , //SW4 ,low active
    inout         IO_man_p_tx,
	inout         IO_man_n_tx, 
	inout         IO_man_p_rx,
	inout         IO_man_n_rx,
    output        dp_rx_hot_plug  ,
    output        LVDS_TX_D3P     ,
	output [3:0]  O_led             //high active
);

//===========================================
localparam AUX_SAMPLE_FREQ = 40;// 40MHz

//===========================================
wire        rst_n1;
wire        rst_n2;
wire        auxrx_rst_n;
wire        auxtx_rst_n;

wire        I_aux_clk;

reg  [31:0] run_cnt;
wire        running;

wire        strm_clk;

//--------------------------
wire        tp0_vs_in  ;
wire        tp0_hs_in  ;
wire        tp0_de_in ;
wire [ 7:0] tp0_data_r;
wire [ 7:0] tp0_data_g;
wire [ 7:0] tp0_data_b;
wire [ 7:0] tp1_data_r;
wire [ 7:0] tp1_data_g;
wire [ 7:0] tp1_data_b;
wire [ 7:0] tp2_data_r;
wire [ 7:0] tp2_data_g;
wire [ 7:0] tp2_data_b;
wire [ 7:0] tp3_data_r;
wire [ 7:0] tp3_data_g;
wire [ 7:0] tp3_data_b;

reg         vs_r;
reg  [9:0]  cnt_vs;

//--------------------------------------
reg         pix_vs_in;
reg         pix_hs_in;
reg         pix_de_in;
reg  [23:0] pix_data0;
reg  [23:0] pix_data1;
reg  [23:0] pix_data2;
reg  [23:0] pix_data3;

//-----------------------------------------------
//tx aux 
wire                    tx_frame_type;
wire                    tx_scrm_value;
wire                    tx_aux_is_ok;
wire                    tx_rply_m_vld;
wire [7:0]              tx_rply_m;   
wire                    tx_rply_ack_vld;
wire [7:0]              tx_rply_ack;         
wire [127:0]            tx_rply_data;
wire [7:0]              tx_rply_len;       
wire                    tx_rply_data_vld;    
wire                    tx_st; 
wire                    tx_i2c_nolen;              
wire [19:0]             tx_addr;             
wire [3:0]              tx_cmd;              
wire [7:0]              tx_len;              
wire [127:0]            tx_data;
wire                    aux_tx_rstn;
// End of automatics 

wire tx_tps1_en;
wire tx_tps2_en;
wire video_data_en;

//--------------------------------------------------
//rx aux
wire                    rx_frame_type;
wire                    rx_scrm_value;
wire                    rx_end; 
wire                    rx_rply_st;        
wire [7:0]              rx_rply_ack;       
wire [127:0]            rx_rply_data;      
wire [7:0]              rx_rply_len; 
wire [7:0]              rx_rply_m;         
wire [19:0]             rx_addr;           
wire [3:0]              rx_cmd; 
wire                    rx_data_st;            
wire [7:0]              rx_data;           
wire [7:0]              rx_len;            
wire                    rx_data_vld;       
wire                    aux_rx_rstn;
// End of automatics

wire rx_tps1_en;
wire rx_tps2_en;

wire        rx0_tps1_ok;
wire        rx1_tps1_ok;
wire        rx2_tps1_ok;
wire        rx3_tps1_ok;

wire        rx0_tps2_ok;
wire        rx1_tps2_ok;
wire        rx2_tps2_ok;
wire        rx3_tps2_ok;

//------------
wire [3:0]  tx0_kcode;
wire [31:0] tx0_data;
wire [3:0]  rx0_kcode;
wire [31:0] rx0_data;

wire [3:0]  tx1_kcode;
wire [31:0] tx1_data;
wire [3:0]  rx1_kcode;
wire [31:0] rx1_data;

wire [3:0]  tx2_kcode;
wire [31:0] tx2_data;
wire [3:0]  rx2_kcode;
wire [31:0] rx2_data;

wire [3:0]  tx3_kcode;
wire [31:0] tx3_data;
wire [3:0]  rx3_kcode;
wire [31:0] rx3_data;

//-----------
wire        ln0_pcs_tx_o_fabric_clk;
wire        ln0_pcs_rx_o_fabric_clk;
wire        ln0_tx_clk;
wire        ln0_rx_clk;
wire        ln0_rx_if_fifo_aempty;

wire        ln1_pcs_tx_o_fabric_clk;
wire        ln1_pcs_rx_o_fabric_clk;
wire        ln1_tx_clk;
wire        ln1_rx_clk;
wire        ln1_rx_if_fifo_aempty;

wire        ln2_pcs_tx_o_fabric_clk;
wire        ln2_pcs_rx_o_fabric_clk;
wire        ln2_tx_clk;
wire        ln2_rx_clk;
wire        ln2_rx_if_fifo_aempty;

wire        ln3_pcs_tx_o_fabric_clk;
wire        ln3_pcs_rx_o_fabric_clk;
wire        ln3_tx_clk;
wire        ln3_rx_clk;
wire        ln3_rx_if_fifo_aempty;

wire        ln0_align_link;
wire        ln1_align_link;
wire        ln2_align_link;
wire        ln3_align_link;

reg         chbond_start;

//-----------
wire [7:0]  vb_id          ;
wire [7:0]  mvid70         ;
wire [7:0]  maud70         ;
wire [23:0] mvid           ;//
wire [23:0] nvid           ;//
wire [15:0] htotal         ;//
wire [15:0] vtotal         ;//
wire [15:0] hstart         ;//
wire [15:0] vstart         ;//
wire [15:0] hwidth         ;//
wire [15:0] vheight        ;//
wire [14:0] hsw            ;//
wire [14:0] vsw            ;//
wire        hsp            ;//
wire        vsp            ;//
wire [7:0]  misc0          ;//
wire [7:0]  misc1          ;//
wire        ls_vs          ;
wire        ls_hs          ;
wire [47:0] unp0_data      ;// 
wire        unp0_data_valid;//
wire [47:0] unp1_data      ;//
wire        unp1_data_valid;//
wire [47:0] unp2_data      ;//
wire        unp2_data_valid;//
wire [47:0] unp3_data      ;//
wire        unp3_data_valid;//

wire        rx_vs   ;
wire        rx_hs   ;
wire        rx_de   ;
wire [7:0]  rx0_r      ; 
wire [7:0]  rx0_g      ; 
wire [7:0]  rx0_b      ; 
wire [7:0]  rx1_r      ; 
wire [7:0]  rx1_g      ; 
wire [7:0]  rx1_b      ;
wire [7:0]  rx2_r      ; 
wire [7:0]  rx2_g      ; 
wire [7:0]  rx2_b      ; 
wire [7:0]  rx3_r      ; 
wire [7:0]  rx3_g      ; 
wire [7:0]  rx3_b      ;

//===========================================
Gowin_PLL Gowin_PLL_inst
(
    .lock   (        ), //output lock
    .clkout0(I_aux_clk), //output clkout0
    .clkin  (I_clk   ), //input clkin
    .reset  (!I_key1) //input reset
);

pix_pll pix_pll_inst
(
    .clkout0(strm_clk), //output clkout0
    .clkin  (I_clk) //input clkin
);

//==================================================================================================== 
key_debounceN #
(
    .DEBCNT1 (32'd25000000 ),//500ms
    .DEBCNT2 (32'd50000000 ) //1s
) 
key_debounceN_inst0
(
    .clk       (I_clk   ), 
    .rst_n     (1'b1    ), 
    .key_in    (I_key1  ),//I_rst_n ), 
    .key_n_out1(rst_n1  ),
    .key_n_out2(rst_n2  )
);

key_debounce #
(
    .DEBCNT (32'd50000000 )//1s
) 
key_debounce_inst0
(
    .clk       (I_clk        ), 
    .rst_n     (1'b1         ), 
    .keyn_in   (I_key2       ),//I_rst_n ), 
    .keyn_out  (auxrx_rst_n  )
);

key_debounce #
(
    .DEBCNT (32'd50000000 )//1s
) 
key_debounce_inst1
(
    .clk       (I_clk        ), 
    .rst_n     (1'b1         ), 
    .keyn_in   (I_key3       ),//I_rst_n ), 
    .keyn_out  (auxtx_rst_n  )
);

//===================================================
//LED test
always @(posedge I_clk or negedge rst_n1) //I_clk
begin
	if(!rst_n1)
		run_cnt <= 32'd0;
	else if(run_cnt >= 32'd50_000_000)
		run_cnt <= 32'd0;
	else
		run_cnt <= run_cnt + 1'b1;
end

assign  running = (run_cnt < 32'd25_000_000) ? 1'b1 : 1'b0;

assign  O_led[0] = running;
assign  O_led[1] = I_key1 & I_key2 & I_key3 & I_key4;
assign  O_led[2] = tx_aux_is_ok;
assign  O_led[3] = rx_end;

assign  dp_rx_hot_plug = auxrx_rst_n;

//====================================================================
testpatternX4 testpatternX4_inst
(
    .I_pxl_clk   (strm_clk           ),//pixel clock
    .I_rst_n     (rst_n2             ),//low active  
    .I_mode      ({2'b10,cnt_vs[8:7]}),//data select
    .I_sqr_width (16'd32             ),
    .I_single_r  (8'd0               ),
    .I_single_g  (8'd255             ),//148.5M(Actually148.3872M)       
    .I_single_b  (8'd0               ),//1920x1080  
    .I_h_total   (16'd550            ),// 16'd2200  
    .I_h_sync    (16'd11             ),// 16'd44    
    .I_h_bporch  (16'd37             ),// 16'd148   
    .I_h_res     (16'd480            ),// 16'd1920  
    .I_v_total   (16'd1125           ),// 16'd1125  
    .I_v_sync    (16'd5              ),// 16'd5     
    .I_v_bporch  (16'd36             ),// 16'd36    
    .I_v_res     (16'd1080           ),// 16'd1080  
    .O_vblank    (                   ),
    .O_hblank    (                   ),  
    .O_vs        (tp0_vs_in          ),//polarity fixed negative
    .O_hs        (tp0_hs_in          ),//polarity fixed negative
    .O_de        (tp0_de_in          ),
    .O_data0_r   (tp0_data_r         ),   
    .O_data0_g   (tp0_data_g         ),
    .O_data0_b   (tp0_data_b         ),
    .O_data1_r   (tp1_data_r         ), 
    .O_data1_g   (tp1_data_g         ),
    .O_data1_b   (tp1_data_b         ),
    .O_data2_r   (tp2_data_r         ), 
    .O_data2_g   (tp2_data_g         ),
    .O_data2_b   (tp2_data_b         ),
    .O_data3_r   (tp3_data_r         ), 
    .O_data3_g   (tp3_data_g         ),
    .O_data3_b   (tp3_data_b         )
);

always@(posedge strm_clk) 
begin
    vs_r<=tp0_vs_in;
end

always@(posedge strm_clk or negedge rst_n2) 
begin
    if(!rst_n2)
        cnt_vs<=10'd0;
    else if(vs_r && !tp0_vs_in) //vs24 falling edge
        cnt_vs<=cnt_vs+1'b1;
end 

//==================================================
always@(posedge strm_clk or negedge rst_n2) 
begin
    if(!rst_n2)
        begin
            pix_vs_in <= 1'd0 ;
            pix_hs_in <= 1'd0 ;
            pix_de_in <= 1'd0 ;
            pix_data0 <= 24'd0;
            pix_data1 <= 24'd0;
            pix_data2 <= 24'd0;
            pix_data3 <= 24'd0;
        end
    else if(rx_end) 
        begin
            pix_vs_in <= rx_vs              ;
            pix_hs_in <= rx_hs              ;
            pix_de_in <= rx_de              ;
            pix_data0 <= {rx0_b,rx0_g,rx0_r};
            pix_data1 <= {rx1_b,rx1_g,rx1_r};
            pix_data2 <= {rx2_b,rx2_g,rx2_r};
            pix_data3 <= {rx3_b,rx3_g,rx3_r};
        end
    else
        begin
            pix_vs_in <= ~tp0_vs_in                        ;
            pix_hs_in <= ~tp0_hs_in                        ;
            pix_de_in <= tp0_de_in                         ;
            pix_data0 <= {tp0_data_b,tp0_data_g,tp0_data_r};
            pix_data1 <= {tp1_data_b,tp1_data_g,tp1_data_r};
            pix_data2 <= {tp2_data_b,tp2_data_g,tp2_data_r};
            pix_data3 <= {tp3_data_b,tp3_data_g,tp3_data_r};
        end
end

//===================================================================
aux_tx #
( 
  .FREQ                (AUX_SAMPLE_FREQ)  
)
aux_tx_inst
( 
 .O_frame_type         (tx_frame_type),
 .O_scrm_value         (tx_scrm_value),
 .O_tx_end             (),
 .O_tx_tps1_en         (tx_tps1_en   ),
 .O_tx_tps2_en         (tx_tps2_en   ),
 .O_tx_video_data_en   (video_data_en),
 .O_tx_aux_is_ok       (tx_aux_is_ok),
 .I_aux_clk            (I_aux_clk),
 .I_aux_rstn           (auxtx_rst_n),
 .O_tx_st              (tx_st),
 .O_tx_i2c_nolen       (tx_i2c_nolen ),
 .O_tx_cmd             (tx_cmd[3:0]),
 .O_tx_addr            (tx_addr[19:0]),
 .O_tx_len             (tx_len[7:0]),
 .O_tx_data            (tx_data[127:0]),
 .I_tx_rply_m_vld      (tx_rply_m_vld),
 .I_tx_rply_m          (tx_rply_m[7:0]),
 .I_tx_rply_ack_vld    (tx_rply_ack_vld),
 .I_tx_rply_ack        (tx_rply_ack[7:0]),
 .I_tx_rply_data       (tx_rply_data),
 .I_tx_rply_len        (tx_rply_len),
 .I_tx_rply_data_vld   (tx_rply_data_vld)
);            

manchester_encode #
( 
  .FREQ                (AUX_SAMPLE_FREQ)  
)
manchester_encode_inst
( 
 .man_test             (),
 .I_clk                (I_aux_clk),
 .I_rstn               (auxtx_rst_n),
 .O_tx_rply_data_vld   (tx_rply_data_vld),
 .O_tx_rply_data       (tx_rply_data[127:0]),
 .O_tx_rply_len        (tx_rply_len),
 .O_tx_rply_ack_vld    (tx_rply_ack_vld),
 .O_tx_rply_ack        (tx_rply_ack[7:0]),
 .O_tx_rply_m_vld      (tx_rply_m_vld),
 .O_tx_rply_m          (tx_rply_m[7:0]),
 .I_tx_st              (tx_st),
 .I_tx_i2c_nolen       (tx_i2c_nolen),
 .I_tx_cmd             (tx_cmd[3:0]),
 .I_tx_addr            (tx_addr[19:0]),
 .I_tx_len             (tx_len[7:0]),
 .I_tx_data            (tx_data[127:0]),
 .IO_man_p             (IO_man_p_tx),
 .IO_man_n             (IO_man_n_tx)
); 

//===================================================
EDP_Encoder_Top EDP_Encoder_Top_inst
(
    .I_rst_n           (rst_n2            ),
    .I_tx_tps1_en      (tx_tps1_en        ),
    .I_tx_tps2_en      (tx_tps2_en        ),
    .I_tx_video_data_en(video_data_en     ),
    .I_frame_type      (tx_frame_type     ),//0:normal_frame  1:enhanced_frame
    .I_scrm_value      (tx_scrm_value     ),//0:DP rst value 0xffff  1:eDP rst value 0xfffe
    .I_vb_id           (8'h10             ),
    .I_msa_mvid        (24'd29987         ), 
    .I_msa_nvid        (24'd32768         ),
    .I_tu_size         (8'd64             ),
    .I_avs_per_tu      (8'd44             ),
    .I_lsck_htotal     (16'd601           ),
    .I_lsck_hblank     (16'd81            ),
    .I_msa_htotal      (16'd2200          ),
    .I_msa_vtotal      (16'd1125          ),
    .I_msa_hstart      (16'd192           ),
    .I_msa_vstart      (16'd41            ),
    .I_msa_hwidth      (16'd1920          ),
    .I_msa_vheight     (16'd1080          ),
    .I_msa_hsphsw      ({1'b0,15'd44}     ),
    .I_msa_vspvsw      ({1'b0,15'd5}      ),
    .I_msa_misc0       (8'h20             ),//8'h20:asynchronous clock  8'h21:synchronous clock
    .I_msa_misc1       (8'h00             ),
    .I_strm_clk        (strm_clk          ),  
    .I_pix_vs          (pix_vs_in         ),
    .I_pix_hs          (pix_hs_in         ),
    .I_pix_de          (pix_de_in         ),
    .I_pix_data0       (pix_data0         ),
    .I_pix_data1       (pix_data1         ),
    .I_pix_data2       (pix_data2         ),
    .I_pix_data3       (pix_data3         ),    
    .I_ls_clk          (ln0_tx_clk        ),     
    .O_tx_data_0       (tx0_data          ),    
    .O_tx_data_1       (tx1_data          ),    
    .O_tx_data_2       (tx2_data          ),    
    .O_tx_data_3       (tx3_data          ),    
    .O_k_code_0        (tx0_kcode         ),    
    .O_k_code_1        (tx1_kcode         ),    
    .O_k_code_2        (tx2_kcode         ),    
    .O_k_code_3        (tx3_kcode         )     
);

//===================================================
assign ln0_tx_clk = ln0_pcs_tx_o_fabric_clk;
assign ln1_tx_clk = ln0_pcs_tx_o_fabric_clk;
assign ln2_tx_clk = ln0_pcs_tx_o_fabric_clk;
assign ln3_tx_clk = ln0_pcs_tx_o_fabric_clk;

assign ln0_rx_clk = ln0_pcs_rx_o_fabric_clk;
assign ln1_rx_clk = ln0_pcs_rx_o_fabric_clk;
assign ln2_rx_clk = ln0_pcs_rx_o_fabric_clk;
assign ln3_rx_clk = ln0_pcs_rx_o_fabric_clk;

SerDes_Top SerDes_Top_inst
(
    .EDP_PHY_Top_ln0_cpll_ok_o         (),
    .EDP_PHY_Top_ln0_fabric_rstn_i     (rst_n1),
    .EDP_PHY_Top_ln0_rx_rst_i          (~rst_n2),
    .EDP_PHY_Top_ln0_chbond_start_i    (chbond_start),
    .EDP_PHY_Top_ln0_pma_rx_lock_o     (),
    .EDP_PHY_Top_ln0_align_link_o      (ln0_align_link),
    .EDP_PHY_Top_ln0_k_lock_o          (),
    .EDP_PHY_Top_ln0_pcs_rx_clk_o      (ln0_pcs_rx_o_fabric_clk),
    .EDP_PHY_Top_ln0_fabric_rx_clk_i   (ln0_rx_clk),
    .EDP_PHY_Top_ln0_rxfifo_aempty_o   (ln0_rx_if_fifo_aempty),
    .EDP_PHY_Top_ln0_rxfifo_empty_o    (),
    .EDP_PHY_Top_ln0_rxfifo_rdusewd_o  (),
    .EDP_PHY_Top_ln0_rxfifo_rden_i     (1'b1),
    .EDP_PHY_Top_ln0_tx_rst_i          (~rst_n2),
    .EDP_PHY_Top_ln0_pcs_tx_clk_o      (ln0_pcs_tx_o_fabric_clk),
    .EDP_PHY_Top_ln0_fabric_tx_clk_i   (ln0_tx_clk),
    .EDP_PHY_Top_ln0_txfifo_afull_o    (),
    .EDP_PHY_Top_ln0_txfifo_full_o     (),
    .EDP_PHY_Top_ln0_txfifo_wrusewd_o  (),
    .EDP_PHY_Top_ln0_tx_vld_i          (1'b1),
    .EDP_PHY_Top_ln0_rxdata_o          (rx0_data ),
    .EDP_PHY_Top_ln0_rxk_o             (rx0_kcode),
    .EDP_PHY_Top_ln0_txdata_i          (tx0_data ),
    .EDP_PHY_Top_ln0_txk_i             (tx0_kcode),
                          
    .EDP_PHY_Top_ln1_cpll_ok_o         (),
    .EDP_PHY_Top_ln1_fabric_rstn_i     (rst_n1),
    .EDP_PHY_Top_ln1_rx_rst_i          (~rst_n2),
    .EDP_PHY_Top_ln1_chbond_start_i    (chbond_start),
    .EDP_PHY_Top_ln1_pma_rx_lock_o     (),
    .EDP_PHY_Top_ln1_align_link_o      (ln1_align_link),
    .EDP_PHY_Top_ln1_k_lock_o          (),
    .EDP_PHY_Top_ln1_pcs_rx_clk_o      (ln1_pcs_rx_o_fabric_clk),
    .EDP_PHY_Top_ln1_fabric_rx_clk_i   (ln1_rx_clk),
    .EDP_PHY_Top_ln1_rxfifo_aempty_o   (ln1_rx_if_fifo_aempty),
    .EDP_PHY_Top_ln1_rxfifo_empty_o    (),
    .EDP_PHY_Top_ln1_rxfifo_rdusewd_o  (),
    .EDP_PHY_Top_ln1_rxfifo_rden_i     (1'b1),
    .EDP_PHY_Top_ln1_tx_rst_i          (~rst_n2),
    .EDP_PHY_Top_ln1_pcs_tx_clk_o      (ln1_pcs_tx_o_fabric_clk),
    .EDP_PHY_Top_ln1_fabric_tx_clk_i   (ln1_tx_clk),
    .EDP_PHY_Top_ln1_txfifo_afull_o    (),
    .EDP_PHY_Top_ln1_txfifo_full_o     (),
    .EDP_PHY_Top_ln1_txfifo_wrusewd_o  (),
    .EDP_PHY_Top_ln1_tx_vld_i          (1'b1),
    .EDP_PHY_Top_ln1_rxdata_o          (rx1_data ),
    .EDP_PHY_Top_ln1_rxk_o             (rx1_kcode),
    .EDP_PHY_Top_ln1_txdata_i          (tx1_data ),
    .EDP_PHY_Top_ln1_txk_i             (tx1_kcode),
                           
    .EDP_PHY_Top_ln2_cpll_ok_o         (),
    .EDP_PHY_Top_ln2_fabric_rstn_i     (rst_n1),
    .EDP_PHY_Top_ln2_rx_rst_i          (~rst_n2),
    .EDP_PHY_Top_ln2_chbond_start_i    (chbond_start),
    .EDP_PHY_Top_ln2_pma_rx_lock_o     (),
    .EDP_PHY_Top_ln2_align_link_o      (ln2_align_link),
    .EDP_PHY_Top_ln2_k_lock_o          (),
    .EDP_PHY_Top_ln2_pcs_rx_clk_o      (ln2_pcs_rx_o_fabric_clk),
    .EDP_PHY_Top_ln2_fabric_rx_clk_i   (ln2_rx_clk),
    .EDP_PHY_Top_ln2_rxfifo_aempty_o   (ln2_rx_if_fifo_aempty),
    .EDP_PHY_Top_ln2_rxfifo_empty_o    (),
    .EDP_PHY_Top_ln2_rxfifo_rdusewd_o  (),
    .EDP_PHY_Top_ln2_rxfifo_rden_i     (1'b1),
    .EDP_PHY_Top_ln2_tx_rst_i          (~rst_n2),
    .EDP_PHY_Top_ln2_pcs_tx_clk_o      (ln2_pcs_tx_o_fabric_clk),
    .EDP_PHY_Top_ln2_fabric_tx_clk_i   (ln2_tx_clk),
    .EDP_PHY_Top_ln2_txfifo_afull_o    (),
    .EDP_PHY_Top_ln2_txfifo_full_o     (),
    .EDP_PHY_Top_ln2_txfifo_wrusewd_o  (),
    .EDP_PHY_Top_ln2_tx_vld_i          (1'b1),
    .EDP_PHY_Top_ln2_rxdata_o          (rx2_data ),
    .EDP_PHY_Top_ln2_rxk_o             (rx2_kcode),
    .EDP_PHY_Top_ln2_txdata_i          (tx2_data ),
    .EDP_PHY_Top_ln2_txk_i             (tx2_kcode),
                           
    .EDP_PHY_Top_ln3_cpll_ok_o         (),
    .EDP_PHY_Top_ln3_fabric_rstn_i     (rst_n1),
    .EDP_PHY_Top_ln3_rx_rst_i          (~rst_n2),
    .EDP_PHY_Top_ln3_chbond_start_i    (chbond_start),
    .EDP_PHY_Top_ln3_pma_rx_lock_o     (),
    .EDP_PHY_Top_ln3_align_link_o      (ln3_align_link),
    .EDP_PHY_Top_ln3_k_lock_o          (),
    .EDP_PHY_Top_ln3_pcs_rx_clk_o      (ln3_pcs_rx_o_fabric_clk),
    .EDP_PHY_Top_ln3_fabric_rx_clk_i   (ln3_rx_clk),
    .EDP_PHY_Top_ln3_rxfifo_aempty_o   (ln3_rx_if_fifo_aempty),
    .EDP_PHY_Top_ln3_rxfifo_empty_o    (),
    .EDP_PHY_Top_ln3_rxfifo_rdusewd_o  (),
    .EDP_PHY_Top_ln3_rxfifo_rden_i     (1'b1),
    .EDP_PHY_Top_ln3_tx_rst_i          (~rst_n2),
    .EDP_PHY_Top_ln3_pcs_tx_clk_o      (ln3_pcs_tx_o_fabric_clk),
    .EDP_PHY_Top_ln3_fabric_tx_clk_i   (ln3_tx_clk),
    .EDP_PHY_Top_ln3_txfifo_afull_o    (),
    .EDP_PHY_Top_ln3_txfifo_full_o     (),
    .EDP_PHY_Top_ln3_txfifo_wrusewd_o  (),
    .EDP_PHY_Top_ln3_tx_vld_i          (1'b1),
    .EDP_PHY_Top_ln3_rxdata_o          (rx3_data ),
    .EDP_PHY_Top_ln3_rxk_o             (rx3_kcode),
    .EDP_PHY_Top_ln3_txdata_i          (tx3_data ),
    .EDP_PHY_Top_ln3_txk_i             (tx3_kcode),
                           
    .EDP_PHY_Top_qpll0_ok_o            (),
    .EDP_PHY_Top_qpll1_ok_o            () 
);

always@(posedge ln0_rx_clk or negedge rst_n2) 
begin
    if(!rst_n2)
        chbond_start <= 1'b0;
    else
        chbond_start <= ln0_align_link & ln1_align_link & ln2_align_link & ln3_align_link;
end

//====================================================================================================   
aux_rx aux_rx_inst
(
 .O_frame_type         (rx_frame_type),
 .O_scrm_value         (rx_scrm_value),
 .O_rx_end             (rx_end),
 .O_rx_tps1_en         (rx_tps1_en   ),
 .O_rx_tps2_en         (rx_tps2_en   ),
 .I_aux_clk            (I_aux_clk),
 .I_aux_rstn           (auxrx_rst_n),//rst_n2),
 .I_rx_cmd             (rx_cmd[3:0]),
 .I_rx_addr            (rx_addr[19:0]),
 .I_rx_data_st         (rx_data_st),
 .I_rx_data            (rx_data),
 .I_rx_data_vld        (rx_data_vld),
 .I_rx_len             (rx_len[7:0]),
 .I_rx_rply_st         (rx_rply_st),
 .O_rx_rply_ack        (rx_rply_ack[7:0]),
 .O_rx_rply_data       (rx_rply_data[127:0]),
 .O_rx_rply_len        (rx_rply_len[7:0]),
 .O_rx_rply_m          (rx_rply_m)
);        

manchester_decode #
( 
  .FREQ                (AUX_SAMPLE_FREQ)  
)
manchester_decode_inst
(
 .man_test             (LVDS_TX_D3P),
 .I_clk                (I_aux_clk),
 .I_rstn               (auxrx_rst_n),//rst_n2),
 .O_rx_cmd             (rx_cmd[3:0]),
 .O_rx_addr            (rx_addr[19:0]),
 .O_rx_data_st         (rx_data_st),
 .O_rx_data            (rx_data),
 .O_rx_data_vld        (rx_data_vld),
 .O_rx_len             (rx_len[7:0]),
 .O_rx_rply_st         (rx_rply_st),
 .I_rx_rply_ack        (rx_rply_ack[7:0]),
 .I_rx_rply_data       (rx_rply_data[127:0]),
 .I_rx_rply_len        (rx_rply_len[7:0]),
 .I_rx_rply_m          (rx_rply_m),
 .IO_man_p             (IO_man_p_rx),
 .IO_man_n             (IO_man_n_rx)
); 

//=================================================
EDP_Decoder_Top EDP_Decoder_Top_inst
( 
    .I_rst_n          (rst_n2         ),//low active
    .I_ls_clk         (ln0_rx_clk     ),
    .I_frame_type     (rx_frame_type  ),//0:normal_frame  1:enhanced_frame
    .I_scrm_value     (rx_scrm_value  ),//0:DP rst value 0xffff  1:eDP rst value 0xfffe
    .O_vb_id          (vb_id          ),
    .O_mvid70         (mvid70         ),
    .O_maud70         (maud70         ),
    .O_mvid           (mvid           ),//
    .O_nvid           (nvid           ),//
    .O_htotal         (htotal         ),//
    .O_vtotal         (vtotal         ),//
    .O_hstart         (hstart         ),//
    .O_vstart         (vstart         ),//
    .O_hwidth         (hwidth         ),//
    .O_vheight        (vheight        ),//
    .O_hsw            (hsw            ),//
    .O_vsw            (vsw            ),//
    .O_hsp            (hsp            ),//
    .O_vsp            (vsp            ),//
    .O_misc0          (misc0          ),//
    .O_misc1          (misc1          ),//
    .O_ls_vs          (ls_vs          ),//postive
    .O_ls_hs          (ls_hs          ),//postive
    .I_kcode0         (rx0_kcode      ),//
    .I_data0          (rx0_data       ),//low byte first
    .I_kcode1         (rx1_kcode      ),//
    .I_data1          (rx1_data       ),//
    .I_kcode2         (rx2_kcode      ),//
    .I_data2          (rx2_data       ),//
    .I_kcode3         (rx3_kcode      ),//
    .I_data3          (rx3_data       ),//
    .O_unp0_data      (unp0_data      ),//low byte first
    .O_unp0_data_valid(unp0_data_valid),//
    .O_unp1_data      (unp1_data      ),//
    .O_unp1_data_valid(unp1_data_valid),//
    .O_unp2_data      (unp2_data      ),//
    .O_unp2_data_valid(unp2_data_valid),//
    .O_unp3_data      (unp3_data      ),//
    .O_unp3_data_valid(unp3_data_valid) //
);

EDP_RX_Desteer_Top EDP_RX_Desteer_Top_inst
( 
    .I_rst_n          (rst_n2         ),//low active
    .I_ls_clk         (ln0_rx_clk     ),
    .I_ls_vs          (ls_vs          ),//postive
    .I_ls_hs          (ls_hs          ),//postive
    .I_htotal         (htotal         ),//
    .I_vtotal         (vtotal         ),//
    .I_hstart         (hstart         ),//
    .I_vstart         (vstart         ),//
    .I_hwidth         (hwidth         ),//
    .I_vheight        (vheight        ),//
    .I_hsw            (hsw            ),//
    .I_vsw            (vsw            ),//
    .I_unp0_data      (unp0_data      ),// 
    .I_unp0_data_valid(unp0_data_valid),//
    .I_unp1_data      (unp1_data      ),//
    .I_unp1_data_valid(unp1_data_valid),//
    .I_unp2_data      (unp2_data      ),//
    .I_unp2_data_valid(unp2_data_valid),//
    .I_unp3_data      (unp3_data      ),//
    .I_unp3_data_valid(unp3_data_valid),//
    .I_strm_clk       (strm_clk       ),//pixel clock
    .O_vcnt_strmclk   (               ),
    .O_hcnt_strmclk   (               ),
    .O_vs             (rx_vs          ),//postive
    .O_hs             (rx_hs          ),//postive
    .O_de             (rx_de          ),//
    .O_data0          ({rx0_b,rx0_g,rx0_r}),//
    .O_data1          ({rx1_b,rx1_g,rx1_r}),//
    .O_data2          ({rx2_b,rx2_g,rx2_r}),//
    .O_data3          ({rx3_b,rx3_g,rx3_r}) //
);


endmodule