
quit -sim

vlib work  

#mapping work library to current directory
#vmap [-help] [-c] [-del] [<logical_name>] [<path>]
vmap work  

#compile all .v files to work library
#-work <path>       Specify library WORK
#-vlog01compat      Ensure compatibility with Std 1364-2001
#-incr              Enable incremental compilation
#"rtl/*.v"          rtl directory all .v files, support relative path, need to add ""
#vlog

#vlog -novopt \
#+incdir+../../project/src/edp_decoder \
#../../project/src/edp_decoder/*.v
vlog -novopt ../../project/src/edp_decoder/edp_decoder.vo

#vlog -novopt \
#+incdir+../../project/src/edp_encoder \
#../../project/src/edp_encoder/*.v
vlog -novopt ../../project/src/edp_encoder/edp_encoder.vo

#vlog -novopt \
#+incdir+../../project/src/edp_rx_desteer \
#../../project/src/edp_rx_desteer/*.v
vlog -novopt ../../project/src/edp_rx_desteer/edp_rx_desteer.vo

vlog -novopt ../../project/src/testpatternX4.v

#testbench
vlog -novopt ../../tb/monitor/*.v
vlog -novopt ../../tb/prim_sim.v

vlog -novopt ../../tb/tb.v

#complie all .vhd files
#-work <path>       Specify library WORK
#-93                Enable support for VHDL 1076-1993
#-2002              Enable support for VHDL 1076-2002
#vcom


#simulate testbench top file
#-L <libname>                     Search library for design units instantiated from Verilog and for VHDL default component binding
#+nowarn<CODE | Number>           Disable specified warning message  (Example: +nowarnTFMPC)                      
#-t [1|10|100]fs|ps|ns|us|ms|sec  Time resolution limit VHDL default: resolution setting from .ini file) 
#                                 (Verilog default: minimum time_precision in the design)
#-novopt                          Force incremental mode (pre-6.0 behavior)
vsim +nowarnTFMPC -L work  -novopt -l tb.log work.tb 

#generate wave log format(WLF)......
log -r /*

#open wave window
view wave

#add simulation singals
onerror {resume}
quietly WaveActivateNextPane {} 0

add wave -noupdate -divider {input paramters}  
add wave -noupdate                    /tb/BMP_PIXEL_CLK_PERIOD 
                                                      
add wave -noupdate -divider {output paramters}        
add wave -noupdate -radix unsigned    /tb/BMP_OUTPUTED_WIDTH   
add wave -noupdate -radix unsigned    /tb/BMP_OUTPUTED_HEIGHT  
add wave -noupdate -radix ascii       /tb/BMP_OUTPUTED_NAME 
add wave -noupdate -radix unsigned    /tb/BMP_OUTPUTED_NUMBER  

add wave -noupdate -divider {driver_inst output}
add wave -noupdate                    /tb/rst_n
add wave -noupdate                    /tb/pixel_clk   
add wave -noupdate                    /tb/tp0_vs_in 
add wave -noupdate                    /tb/tp0_hs_in 
add wave -noupdate                    /tb/tp0_de_in  
add wave -noupdate -radix hexadecimal /tb/tp0_data_r
add wave -noupdate -radix hexadecimal /tb/tp0_data_g
add wave -noupdate -radix hexadecimal /tb/tp0_data_b 
add wave -noupdate -radix hexadecimal /tb/tp1_data_r
add wave -noupdate -radix hexadecimal /tb/tp1_data_g
add wave -noupdate -radix hexadecimal /tb/tp1_data_b 
add wave -noupdate -radix hexadecimal /tb/tp2_data_r
add wave -noupdate -radix hexadecimal /tb/tp2_data_g
add wave -noupdate -radix hexadecimal /tb/tp2_data_b 
add wave -noupdate -radix hexadecimal /tb/tp3_data_r
add wave -noupdate -radix hexadecimal /tb/tp3_data_g
add wave -noupdate -radix hexadecimal /tb/tp3_data_b 

add wave -noupdate -divider {TX output}
add wave -noupdate                    /tb/ls_clock
add wave -noupdate -radix hexadecimal /tb/tx0_kcode
add wave -noupdate -radix hexadecimal /tb/tx0_data 
add wave -noupdate -radix hexadecimal /tb/tx1_kcode
add wave -noupdate -radix hexadecimal /tb/tx1_data 
add wave -noupdate -radix hexadecimal /tb/tx2_kcode
add wave -noupdate -radix hexadecimal /tb/tx2_data 
add wave -noupdate -radix hexadecimal /tb/tx3_kcode
add wave -noupdate -radix hexadecimal /tb/tx3_data 

add wave -noupdate -divider {RX signals}   
add wave -noupdate                    /tb/ls_vs   
add wave -noupdate                    /tb/ls_hs 
add wave -noupdate                    /tb/unp0_data_valid  
add wave -noupdate -radix hexadecimal /tb/unp0_data  
add wave -noupdate                    /tb/unp1_data_valid   
add wave -noupdate -radix hexadecimal /tb/unp1_data 
add wave -noupdate                    /tb/unp2_data_valid     
add wave -noupdate -radix hexadecimal /tb/unp2_data 
add wave -noupdate                    /tb/unp3_data_valid  
add wave -noupdate -radix hexadecimal /tb/unp3_data      

add wave -noupdate -divider {monitor input}
add wave -noupdate                    /tb/m_clk
add wave -noupdate                    /tb/m_vs_rgb
add wave -noupdate                    /tb/m_hs_rgb
add wave -noupdate                    /tb/m_de_rgb
add wave -noupdate -radix hexadecimal /tb/m_data0_r
add wave -noupdate -radix hexadecimal /tb/m_data0_g
add wave -noupdate -radix hexadecimal /tb/m_data0_b
add wave -noupdate -radix hexadecimal /tb/m_data1_r
add wave -noupdate -radix hexadecimal /tb/m_data1_g
add wave -noupdate -radix hexadecimal /tb/m_data1_b
add wave -noupdate -radix hexadecimal /tb/m_data2_r
add wave -noupdate -radix hexadecimal /tb/m_data2_g
add wave -noupdate -radix hexadecimal /tb/m_data2_b
add wave -noupdate -radix hexadecimal /tb/m_data3_r
add wave -noupdate -radix hexadecimal /tb/m_data3_g
add wave -noupdate -radix hexadecimal /tb/m_data3_b

add wave -noupdate -divider {monitor signal}
add wave -noupdate -radix unsigned    /tb/monitor_inst/u_video2bmp/bmp_outputed_number
add wave -noupdate                    /tb/monitor_inst/u_video2bmp/vs_i_fall

add wave -noupdate -divider {End signal}

TreeUpdate [SetDefaultTree]
WaveRestoreCursors {{Cursor 1} {912366093 ps} 0}
configure wave -namecolwidth 150
configure wave -valuecolwidth 100
update
WaveRestoreZoom {891247063 ps} {925431255 ps}

#set run time
run  -all



